<xsl:stylesheet xmlns:xsl='http://www.w3.org/1999/XSL/Transform' xmlns:saxon="http://icl.com/saxon" extension-element-prefixes="saxon" version="1.0">  

<xsl:output method="xml" indent="yes"/>

<xsl:key name="element" match="element" use="@name"/>
<xsl:key name="attribute" match="attribute" use="concat(parent::element/@name,':::',@name)"/>
<xsl:key name="child" match="child" use="concat(parent::element/@name,':::',.)"/>

<xsl:template match="/">
  <elements>
    <element name="PCDATA">
      <dtd name="Frameset"/>
      <dtd name="Strict"/>
      <dtd name="Transitional"/>
    </element>
    <xsl:apply-templates select="//element"/>
  </elements>
</xsl:template>

<xsl:template match="element">
  <xsl:variable name="xxx" select="key('element',@name)"/>
  <xsl:if test="generate-id() = generate-id($xxx)">
    <element name="{@name}">
      <xsl:apply-templates select="$xxx" mode="dtd"/>
      <xsl:apply-templates select="$xxx/attribute"/>
      <xsl:apply-templates select="$xxx/child"/>
    </element>
  </xsl:if>
</xsl:template>

<xsl:template match="element|attribute|child" mode="dtd">
  <dtd name="{ancestor::xhtmlReference/@dtd}"/>
</xsl:template>

<xsl:template match="attribute">
  <xsl:variable name="xxx" select="key('attribute',concat(parent::element/@name,':::',@name))"/>
  <xsl:if test="generate-id() = generate-id($xxx)">
    <attribute name="{@name}">
      <xsl:apply-templates select="$xxx" mode="dtd"/>
    </attribute>
  </xsl:if>
</xsl:template>

<xsl:template match="child">
  <xsl:variable name="xxx" select="key('child',concat(parent::element/@name,':::',.))"/>
  <xsl:if test="generate-id() = generate-id($xxx)">
    <child name="{.}">
      <xsl:apply-templates select="$xxx" mode="dtd"/>
    </child>
  </xsl:if>
</xsl:template>

</xsl:stylesheet>








